/************************************************************/
/*---------Class definitions for Profile  program-----------*/
/************************************************************/

#include <icmdhdr.hpp>         //ICommand handler
#include <iselhdr.hpp>         //ISelect handler
#include <imenuhdr.hpp>        //IMenuHandler handler
#include <os2/os2.h>

class    IPushButton;
class    IListBox;
class    IString;
class    IFrameWindow;
class    IProfile;
class    IMultiLineEdit;
class    ISetCanvas;
class    ISplitCanvas;
class    AClrDialog;

/***********************************************************/
/*  Popup Handler class definition                        **/
/***********************************************************/

class APopUpHandler : public IMenuHandler
{
    protected:
      virtual Boolean makePopUpMenu(IMenuEvent& menuEvent);

    public:
      IWindow    *popUpOwner;
};

/***********************************************************/
/*  Main Class definition                                 **/
/***********************************************************/

class AProfWindow : public IFrameWindow,
                    public ISelectHandler,
                    public ICommandHandler
{
  public:
    AProfWindow(unsigned long windowId);   //constructor
    void ASetPrMenu(BOOL bFlag);           //  enable/disable process menu items
    void ARefrProf(void);                  //  refresh app names
    void ARefrKeys(void);                  //  refresh keyword names
    void ARefrValue(void);                 //  refresh value

  protected:
    Boolean command(ICommandEvent& cmdEvent);    //command messages
    Boolean selected(IControlEvent& ctrlEvent);  //select control messages

  private:
    IMenuBar         menuBar;        //main window menu
    ISplitCanvas     isCnv1,
                     isCnv2,
                     isCnv3;
    ISetCanvas       isSet1;
    IListBox         listBox;        //appname listbox
    IListBox         listBox2;       //keyword name listbox
    IMultiLineEdit   mle1;           //value multiline edit
    IPushButton      pbDone;         //DONE pushbutton
    IPushButton      pbKey;          //KEYS pushbutton
    IPushButton      pbValue;        //VALUE pushbutton
    IProfile        *myProfile;      //profile object
    IProfile::Cursor *myCursor;      //profile appname cursor

    IWindow         *popupOwner;
    APopUpHandler    popUpHandler;
    AClrDialog      *clrDialog;

    char             prfName[64];    //current profile name
    BOOL             bPrFlag;        //profile active flag
    char             cvMode;         //hex or char mode
 };

